#include <bits/stdc++.h>

#define MAX 1010101
#define MOD 1000000007
#define EPS 1e-6
#define inf 0x3f3f3f3f
#define llinf 0x3f3f3f3f3f3f3f3f

#define fi first
#define se second
#define sz size()
#define pb push_back
#define ende '\n'

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define mset(x, y) memset(&x, (y), sizeof(x))

using namespace std; 

typedef long long ll;
typedef pair<int,int> ii;

ll v[MAX];
ll n, k, r;
vector<ll> tree[MAX];
vector<ll> res;

void merge(vector<ll> a, vector<ll> b, vector<ll> &ans) {
  int i = 0, j = 0, cnt = 0;
  for ( ; cnt < k && i < a.size() && j < b.size(); ++cnt)
    if (a[i] > b[j])
      ans.push_back(a[i++]);
    else
      ans.push_back(b[j++]);

  if (cnt < k) {
    if (i < a.size())
      for (; cnt < k && i < a.size(); ++i, ++cnt)
        ans.push_back(a[i]);
    else
      for (; cnt < k && j < b.size(); ++j, ++cnt)
        ans.push_back(b[j]);
  }
}


void build(int node = 1, int a = 0, int b = n - 1) {
  if (a > b)
    return;
  if (a == b) {
    tree[node].push_back(v[a]);
    return;
  }

  build(node * 2, a, (a + b) / 2);
  build(node * 2 + 1, 1 + (a + b) / 2, b);
  merge(tree[node * 2], tree[node * 2 + 1], tree[node]);
}


void query(int i, int j, int node = 1, int a = 0, int b = n - 1) {
  if (a > b || a > j || b < i)
    return;
  if (a >= i && b <= j) {
    res.insert(res.end(), tree[node].begin(), tree[node].end());
    return;
  }

  query(i, j, node * 2, a, (a + b) / 2);
  query(i, j, 1 + node * 2, 1 + (a + b) / 2, b);
}


int main() {
  ios::sync_with_stdio(0);
  cin.tie(0);

  cin >> n >> k >> r;
  for (int i = 0; i < n; ++i)
    cin >> v[i];
  build();

  for (int i = 0; i < r; ++i) {
    int ans = 1;
    res.clear();
    ll a, b; cin >> a >> b;
    query(a - 1, b - 1);

    sort(res.begin(), res.end());

    int cnt = 0;
    for (int j = res.size() - 1; j >= 0; --j) {
      if (cnt >= k || res[j] == 0) {
        if (res[j] == 0 && j == res.size() - 1)
          ans = 0;
        break;
      }
      ans = (ans * res[j]) % MOD;
      cnt++;
    }

    cout << ans << ende;
  }

  return 0;
}
